import { Reducer } from "redux";
import { AsyncAction } from "../..";
import { AsyncCollection, Result, RequestState } from "./types";
export declare const REQUEST_INITIAL_STATE: RequestState<any>;
export declare function createRequestReducer<TResult = any, TPayload = void, TError = Error>(action: AsyncAction<TResult, TPayload, TError>): Reducer<RequestState<TError>>;
export declare const ASYNC_COLLECTION_INITIAL_STATE: AsyncCollection<any, any>;
export declare function createAsyncCollectionReducer<TData, TPayload = void, TError = Error, TResult extends Result<TData[]> = Result<TData[]>>(options: {
    action: AsyncAction<TResult, TPayload, TError>;
    idKey: keyof TData;
    initialState?: Partial<AsyncCollection<TData, TError>>;
    mergeStrategy?: "merge" | "overwrite";
}): Reducer<AsyncCollection<TData, TError>>;
