import { Tree } from "./helpers/objects";
import { ActionCreator } from "./core";
import { SelectorSpec } from "./redux";
/**
 * Return store-bound action-creators.
 *
 * @param unboundActions action-creators generated by "re-reduced/createActions"
 */
export declare function useActions<TActions extends Tree<ActionCreator<any>>>(unboundActions: TActions): TActions;
export declare type SimpleMapStateToProps<TResult, TState> = (state: TState) => TResult;
/**
 * Returns the deriver redux state based on a map of state seelctors
 *
 * @param stateMapper either normal mapStateToProps (without ownProps as 2nd parameter) or selectorSpecs
 */
export declare function useReduxState<TResult, TState = any>(stateMapper: SelectorSpec<TResult, TState> | SimpleMapStateToProps<TResult, TState>): TResult;
