import { __assign } from "tslib";
import { combineReducers } from "redux";
import uniq from "ramda/src/uniq";
import always from "ramda/src/always";
import mergeLeft from "ramda/src/mergeLeft";
import indexBy from "ramda/src/indexBy";
import { createReducer, foldP, fold, reduce } from "../..";
import { REQUEST_STATUS } from "./types";
export var REQUEST_INITIAL_STATE = {
    status: REQUEST_STATUS.Idle,
};
export function createRequestReducer(action) {
    var INITIAL_STATE = REQUEST_INITIAL_STATE;
    return createReducer([
        reduce(action.request, function (state) { return (__assign(__assign({}, state), { error: undefined, status: REQUEST_STATUS.Pending, lastRequested: Date.now() })); }),
        reduce(action.success, function (state) { return (__assign(__assign({}, state), { error: undefined, status: REQUEST_STATUS.Fulfilled, lastExecuted: Date.now() })); }),
        reduce(action.failure, function (state, error) { return (__assign(__assign({}, state), { error: error, status: REQUEST_STATUS.Failed })); }),
        reduce(action.cancel, function (state) { return (__assign(__assign({}, state), { status: REQUEST_STATUS.Cancelled })); }),
    ], INITIAL_STATE);
}
export var ASYNC_COLLECTION_INITIAL_STATE = {
    byId: {},
    idList: [],
    request: REQUEST_INITIAL_STATE,
};
export function createAsyncCollectionReducer(options) {
    var defaultState = ASYNC_COLLECTION_INITIAL_STATE;
    var INITIAL_STATE = options.initialState
        ? mergeLeft(defaultState, options.initialState)
        : defaultState;
    return combineReducers({
        byId: createReducer(foldP(options.action.success, function (payload) {
            var indexed = indexBy(function (item) { return String(item[options.idKey]); }, payload.items);
            return options.mergeStrategy === "merge"
                ? mergeLeft(indexed)
                : always(indexed);
        }), INITIAL_STATE.byId),
        idList: createReducer(fold(options.action.success, function (payload, state) {
            var ids = payload.items.map(function (item) { return String(item[options.idKey]); });
            return options.mergeStrategy === "merge"
                ? uniq(state.concat(ids))
                : ids;
        }), INITIAL_STATE.idList),
        request: createRequestReducer(options.action),
    });
}
//# sourceMappingURL=reducers.js.map