import { __generator } from "tslib";
import { call, fork, put, } from "redux-saga/effects";
/**
 * Higher order saga for handling common remote resource fetching and error handling routines
 *
 * @param asyncAction
 * @param asyncHandler
 * @param hooks
 */
export function apiWorkerFactory(asyncAction, asyncHandler, hooks) {
    return function sagaWorker(action) {
        var result, _a, error_1;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _b.trys.push([0, 10, , 15]);
                    return [4 /*yield*/, put(asyncAction.request())];
                case 1:
                    _b.sent();
                    if (!(typeof action.payload === "undefined")) return [3 /*break*/, 3];
                    return [4 /*yield*/, call(asyncHandler)];
                case 2:
                    _a = _b.sent();
                    return [3 /*break*/, 5];
                case 3: return [4 /*yield*/, call(asyncHandler, action.payload)];
                case 4:
                    _a = _b.sent();
                    _b.label = 5;
                case 5:
                    result = _a;
                    if (!(hooks && hooks.onSuccess)) return [3 /*break*/, 7];
                    return [4 /*yield*/, fork(hooks.onSuccess, result, action)];
                case 6:
                    _b.sent();
                    return [3 /*break*/, 9];
                case 7: return [4 /*yield*/, put(asyncAction.success(result))];
                case 8:
                    _b.sent();
                    _b.label = 9;
                case 9: return [3 /*break*/, 15];
                case 10:
                    error_1 = _b.sent();
                    if (!(hooks && hooks.onFailure)) return [3 /*break*/, 12];
                    return [4 /*yield*/, fork(hooks.onFailure, error_1, action)];
                case 11:
                    _b.sent();
                    return [3 /*break*/, 14];
                case 12: return [4 /*yield*/, put(asyncAction.failure(error_1))];
                case 13:
                    _b.sent();
                    _b.label = 14;
                case 14: return [3 /*break*/, 15];
                case 15: return [2 /*return*/];
            }
        });
    };
}
//# sourceMappingURL=sagas.js.map